LeetCode—74. 搜索二维矩阵(中等)

仅供个人学习使用

题目描述:

给你一个满足下述两条属性的 m x n 整数矩阵:

  • 每行中的整数从左到右按非严格递增顺序排列。

  • 每行的第一个整数大于前一行的最后一个整数。

给你一个整数 target ,如果 target 在矩阵中,返回 true ;否则,返回 false 。

示例1:

输入: matrix = \[1,3,5,7,10,11,16,20,23,30,34,60], target = 3
**输出:**true

示例2:

输入: matrix = \[1,3,5,7,10,11,16,20,23,30,34,60], target = 13
**输出:**false

题目解析:

因为矩阵具有单调性,所以可以将问题转化为一维数组的查找问题。具体步骤如下:

  1. 初始化 :设置两个指针low和high,分别指向矩阵的左上角(0,0)和右下角(m*n-1),其中m是矩阵的行数,n是矩阵的列数。

  2. 二分查找 :在low和high之间进行二分查找。

    • 计算中间位置mid。
    • 根据mid计算出在矩阵中对应的元素x,即matrix[mid / n][mid % n]。这里mid / n计算出中间位置所在的行,mid % n计算出中间位置所在的列。
  3. 比较与调整:

    • 如果x小于target,则将low指针移动到mid + 1,因为target一定在mid的右边。
    • 如果x大于target,则将high指针移动到mid - 1,因为target一定在mid的左边。
    • 如果x等于target,则返回true,表示找到了目标值。
  4. 循环结束 :如果low超过了high,则表示没有找到目标值,返回false。

实现代码:

java 复制代码
class Solution {
    public boolean searchMatrix(int[][] matrix, int target) {
        int m = matrix.length,n = matrix[0].length;
        int low = 0,high = m * n -1;
        while(low <= high){
            int mid = (low + high)/2;
            int x = matrix[mid / n][mid % n];
            if(x < target){
                low = mid + 1;
            }else if(x > target){
                high = mid - 1;
            }else return true;
        }
        return false;
    }
}
相关推荐
怕浪猫28 分钟前
Super-agent 在各大模型厂商的应用情况
算法·面试·github
海绵宝宝转agent1 小时前
LeetCode100 二叉树个人题解
算法·leetcode·深度优先
octopus_c1 小时前
C++ 模板详解:函数模板、类模板、特化与分离编译
开发语言·c++·算法
東隅已逝,桑榆非晚1 小时前
算法1. 双指针法-移动零
c++·算法
CQU_JIAKE2 小时前
11.1[A]
算法
文丑颜不良啊2 小时前
LeetCode1581~1600题目解析
java·leetcode
小郎君6582 小时前
(六)el-cascader 的展示值为什么不能直接 join:emitPath、路径还原与多选去重
vue.js·算法
郝学胜-神的一滴4 小时前
游戏设计:原型与开发 19:U3D工位布置与性格说明书
人工智能·算法·unity·unreal engine·游戏策划·游戏设计
hahaha60165 小时前
数字图像时域滤波或者3D降噪算法FPGA实现
算法·计算机视觉·fpga开发
文丑颜不良啊5 小时前
LeetCode1541~1560题目解析
java·leetcode